/* filreg.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* $Procedure      FILREG ( File Registry ) */
/* Subroutine */ int filreg_0_(int n__, char *file, ftnlen file_len)
{
    /* Initialized data */

    static integer nfile = 0;

    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    integer s_rnge(char *, integer, char *, integer);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    extern logical ison_(char *, ftnlen);
    integer i__, r__;
    static char files[255*100];
    extern integer rtrim_(char *, ftnlen);
    extern /* Subroutine */ int kilfil_(char *, ftnlen);

/* $ Abstract */

/*     This routine is an umbrella for a pair of entry points that */
/*     maintains/deletes a list of files created within a test family. */

/* $ Disclaimer */

/*     THIS SOFTWARE AND ANY RELATED MATERIALS WERE CREATED BY THE */
/*     CALIFORNIA INSTITUTE OF TECHNOLOGY (CALTECH) UNDER A U.S. */
/*     GOVERNMENT CONTRACT WITH THE NATIONAL AERONAUTICS AND SPACE */
/*     ADMINISTRATION (NASA). THE SOFTWARE IS TECHNOLOGY AND SOFTWARE */
/*     PUBLICLY AVAILABLE UNDER U.S. EXPORT LAWS AND IS PROVIDED "AS-IS" */
/*     TO THE RECIPIENT WITHOUT WARRANTY OF ANY KIND, INCLUDING ANY */
/*     WARRANTIES OF PERFORMANCE OR MERCHANTABILITY OR FITNESS FOR A */
/*     PARTICULAR USE OR PURPOSE (AS SET FORTH IN UNITED STATES UCC */
/*     SECTIONS 2312-2313) OR FOR ANY PURPOSE WHATSOEVER, FOR THE */
/*     SOFTWARE AND RELATED MATERIALS, HOWEVER USED. */

/*     IN NO EVENT SHALL CALTECH, ITS JET PROPULSION LABORATORY, OR NASA */
/*     BE LIABLE FOR ANY DAMAGES AND/OR COSTS, INCLUDING, BUT NOT */
/*     LIMITED TO, INCIDENTAL OR CONSEQUENTIAL DAMAGES OF ANY KIND, */
/*     INCLUDING ECONOMIC DAMAGE OR INJURY TO PROPERTY AND LOST PROFITS, */
/*     REGARDLESS OF WHETHER CALTECH, JPL, OR NASA BE ADVISED, HAVE */
/*     REASON TO KNOW, OR, IN FACT, SHALL KNOW OF THE POSSIBILITY. */

/*     RECIPIENT BEARS ALL RISK RELATING TO QUALITY AND PERFORMANCE OF */
/*     THE SOFTWARE AND ANY RELATED MATERIALS, AND AGREES TO INDEMNIFY */
/*     CALTECH AND NASA FOR ALL THIRD-PARTY CLAIMS RESULTING FROM THE */
/*     ACTIONS OF RECIPIENT IN THE USE OF THE SOFTWARE. */

/* $ Required_Reading */

/*     None. */

/* $ Keywords */

/*     Testing */

/* $ Declarations */
/* $ Brief_I/O */

/*     VARIABLE  I/O  ENTRY POINT */
/*     --------  ---  -------------------------------------------------- */
/*     FILE       I   TFILES */
/*     MAXFIL     P   Maximum number of files that can be maintained. */

/* $ Detailed_Input */

/*     FILE       is some file that should be registered as a file */
/*                created by a Test Utility routine.  This file */
/*                will be "killed" (through a call to KILFIL) */
/*                when the entry point KFILES is called. */

/* $ Detailed_Output */

/*     None. */

/* $ Parameters */

/*     MAXFIL     is the maximum number of files that can be maintained */
/*                by the file registry. */

/* $ Files */

/*     None. */

/* $ Exceptions */

/*     Error free. */

/*     1) All files supplied to TFILES after the MAXFILth file */
/*        has been supplied without a call to KFILES will be */
/*        ignored. */

/* $ Particulars */

/*     This is a utility routine that allows test utility routines */
/*     that create files, to register these files with a central */
/*     manager. */

/*     This allows TOPEN and TCLOSE to delete all such files so that */
/*     test families organized into a test program (as in tspice) will */
/*     automatically clean up after themselves without leaving */
/*     test files on disk as part of the debris of performing a test. */

/*     ========================================================== */
/*     ========================================================== */

/*     NOTE: If the user supplied the debugging flag '-D' in the */
/*     invocation of the test program, or if the user explicitely */
/*     turns on debugging by calling the function SETON as */
/*     shown below */

/*        DUMMY = SETON ( 'DEBUGGING' ) */

/*     Files supplied to TFILES are ignored and as such will not */
/*     be deleted. */

/*     By placing function invocations */

/*          SETON/SETOFF ( 'DEBUGGING' ) */

/*     in balanced pairs within a test family, programmers can override */
/*     the normal clean up activities of TOPEN and TCLOSE. */


/* $ Examples */

/*     If you create a new test file generator, you should insert */
/*     the following call somewhere in the file. */

/*        CALL TFILE ( <name of the test file> ) */

/*     By so doing, all files generated by the test utilities will */
/*     be cleaned up by the test program alleviating programmers */
/*     from the error prone responsibility of cleaning up test files */
/*     at the end of a test family. */

/* $ Restrictions */

/*     None. */

/* $ Author_and_Institution */

/*     W.L. Taber      (JPL) */

/* $ Literature_References */

/*     None. */

/* $ Version */

/* -    Test Utilities Version 1.0.0, 28-JUL-1999 (WLT) */


/* -& */
    switch(n__) {
	case 1: goto L_tfiles;
	case 2: goto L_kfiles;
	}

    return 0;

/*     The next entry point registers a file. */


L_tfiles:

/*        Don't register files when we are in DEBUGGING mode. */

    if (ison_("DEBUGGING", (ftnlen)9)) {
	return 0;
    }
    if (nfile < 100) {
	++nfile;
	s_copy(files + ((i__1 = nfile - 1) < 100 && 0 <= i__1 ? i__1 : s_rnge(
		"files", i__1, "filreg_", (ftnlen)180)) * 255, file, (ftnlen)
		255, file_len);
    }
    return 0;

/*     This entry point deletes all registered files. */


L_kfiles:
    i__1 = nfile;
    for (i__ = 1; i__ <= i__1; ++i__) {
	r__ = rtrim_(files + ((i__2 = i__ - 1) < 100 && 0 <= i__2 ? i__2 : 
		s_rnge("files", i__2, "filreg_", (ftnlen)193)) * 255, (ftnlen)
		255);
	kilfil_(files + ((i__2 = i__ - 1) < 100 && 0 <= i__2 ? i__2 : s_rnge(
		"files", i__2, "filreg_", (ftnlen)194)) * 255, r__);
    }
    nfile = 0;
    return 0;
} /* filreg_ */

/* Subroutine */ int filreg_(char *file, ftnlen file_len)
{
    return filreg_0_(0, file, file_len);
    }

/* Subroutine */ int tfiles_(char *file, ftnlen file_len)
{
    return filreg_0_(1, file, file_len);
    }

/* Subroutine */ int kfiles_(void)
{
    return filreg_0_(2, (char *)0, (ftnint)0);
    }

